Bug 122936

Summary: [ucom] [ubsa] Device does not receive interrupt
Product: Base System Reporter: kamikaze
Component: usbAssignee: freebsd-usb mailing list <usb>
Status: Closed FIXED    
Severity: Affects Only Me    
Priority: Normal    
Version: unspecified   
Hardware: Any   
OS: Any   

Description kamikaze 2008-04-20 18:50:02 UTC
I'm using a USB UMTS modem (Huawei Mobile Compact HSDPA USB Stick), which also attaches as a CD-drive (with the Windows drivers) and is an XD-card reader. When the ubsa module is loaded only the modem part is recognized, though. This doesn't matter in my case, because the modem part is all I care about. The following snippet from messages will demonstrate my problem:

Apr 20 19:00:33 mobileKamikaze root: Unknown USB device: vendor 0x12d1 product 0x1001 bus uhub3
Apr 20 19:00:33 mobileKamikaze kernel: ucom0: <&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533; HUAWEI Mobile, class 0/0, rev 1.10/0.00, addr 3> on uhub3
Apr 20 19:00:33 mobileKamikaze kernel: ucom0: Could not find interrupt in
Apr 20 19:00:33 mobileKamikaze kernel: device_attach: ucom0 attach returned 6
Apr 20 19:00:38 mobileKamikaze kernel: ucom0: at uhub3 port 1 (addr 3) disconnected
Apr 20 19:00:48 mobileKamikaze kernel: ucom0: <&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533; HUAWEI Mobile, class 0/0, rev 1.10/0.00, addr 3> on uhub3
Apr 20 19:00:48 mobileKamikaze kernel: ucom0: Could not find interrupt in
Apr 20 19:00:48 mobileKamikaze kernel: device_attach: ucom0 attach returned 6

I have dug into ubsa.c and ucom.c, the problem appears to be lying deeper in the innards of the USB stack.

If I unplug the device and plug it back in a couple of times (sometimes only 2 or three times, sometimes I have to try for an hour) the stick gets initialized properly:

Apr 20 19:01:30 mobileKamikaze kernel: ucom0: <&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533;&#65533; HUAWEI Mobile, class 0/0, rev 1.10/0.00, addr 3> on uhub3

It appears that how often I have to try depends on the connection quality. Once the device is attached properly, it works without problems. I am writing this PR from a train.

How-To-Repeat: Just plug in an affected stick.
Comment 1 Mark Linimon freebsd_committer freebsd_triage 2008-04-20 20:25:39 UTC
Responsible Changed
From-To: freebsd-bugs->freebsd-usb

Reclassify.
Comment 2 kamikaze 2009-03-24 05:59:40 UTC
U3G has made this not worth bothering. I suggest this be closed.
Maybe strip support for the device from ubsa. It's just a lot more
pleasant experience with u3g.
Comment 3 kamikaze 2009-07-03 08:23:59 UTC
Since U3G made it into the last release, this really should be closed.
Comment 4 kamikaze 2010-09-07 14:53:03 UTC
This is a reminder to close this PR.
Comment 5 Kurt Jaeger freebsd_committer 2014-05-12 10:54:20 UTC
State Changed
From-To: open->closed

Closed on submitter request.